--Best = 778

local M = {}

local scoreLand = 0
local distance = 0
local snakeDistance = 0
local reset = true
local file = require('scenario/fileHandler')

local function onRaceStart()
	if not start then start = true end
end

local function success(score)
	local medal, nextMedal
	if score < 200 then 
		medal = 'None'
		nextMedal = 'Bronze(200)'
	elseif score >= 200 and score < 400 then 
		medal = 'Bronze'
		nextMedal = 'Silver(400)'
	elseif score >= 400 and score < 500 then 
		medal = 'Silver'
		nextMedal = 'Gold(500)'
	elseif score >= 500 and score < 575 then 
		medal = 'Gold'
		nextMedal = 'Platinum(575)'
	elseif score >= 575 and score < 625 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(625)'
	elseif score >= 625 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 24, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'gravity' then
		local playerObject = scenetree.findObject('player')
		playerObject:queueLuaCommand('obj:setWind(0, 750, 0)')
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			snake1.position = "488.258423 -348.977509 1185";
			snake2.position = "-875.94928 -320.932495 778.387268";
			snake3.position = "747.63562 210.658005 935.049988";
		]])
		reset = false
		start = false
	end
	
	if start then
		snakeDistance = snakeDistance+(dt*55)
		TorqueScript.eval([[
			snake1.position = "]]..(-snakeDistance+488.258423)..[[ -348.977509 1185";
			snake2.position = "]]..( snakeDistance-875.94928)..[[ -320.932495 778.387268";
			snake3.position = "]]..(-snakeDistance+747.63562)..[[ 210.658005 935.049988";
		]])
	end
end

local function onRaceTick(raceTickTime)
	local playerObject = scenetree.findObject('player')
	distance = math.floor(playerObject:getPosition().y-1667)
	
	if playerObject:getPosition().z <= 215 then success(distance) end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onPreRender = onPreRender
return M