--Best =1675

local M = {}
local scoreFinal = 0
local scenarioTime = 0
local file = require('scenario/fileHandler')
local helper = require('scenario/scenariohelper')
local crystalHandling = require('scenario/crystalHandler')
local targetTime = 0
local targetScore = -1

local function onRaceStart()
	if not start then start = true end
end

local function success(score, targetsPoints, timePoints)
	local medal, nextMedal
	if score < 600 then 
		medal = 'None'
		nextMedal = 'Bronze(600)'
	elseif score >= 600 and score < 800 then 
		medal = 'Bronze'
		nextMedal = 'Silver(800)'
	elseif score >= 800 and score < 950 then 
		medal = 'Silver'
		nextMedal = 'Gold(950)'
	elseif score >= 950 and score < 1000 then 
		medal = 'Gold'
		nextMedal = 'Platinum(1000)'
	elseif score >= 1000 and score < 1200 then 
		medal = 'Platinum'
		nextMedal = 'Diamond(1200)'
	elseif score >= 1200 then 
		medal = 'Diamond'
		nextMedal = 'n/a'
	else
		medal = 'Broken'
		nextMedal = 'Also Broken'
	end
	
	file.updateFile(file.getMedalAsNumber(medal), 23, nil, nil)
	
    local result = {msg = 'Well Done! Your Score: ('..targetsPoints..'+'..timePoints..') = '..score..' | You Achieved: '..medal..' | Next Medal: '..nextMedal..''}
	scenario_scenarios.finish(result)
end

local function finish()
	local targetsPoints = scoreFinal
	local timePoints = (180-scenarioTime)*10
	scoreFinal = math.floor(scoreFinal+(180-scenarioTime)*10)
	success(scoreFinal, targetsPoints, timePoints)
end

local function onBeamNGTrigger(data)
	if data.event == 'enter' and (data.triggerName ~= 'finish' and data.triggerName ~= 'crystal_pickup') then
		if string.match(data.triggerName, "reset") then TorqueScript.eval('player.rotation = "0 0 1 90";')
		else 
			local targetPts = tonumber(string.match(data.triggerName, '%d+'))
			targetTime = 0.25
			targetScore = targetScore+targetPts
			scoreFinal = scoreFinal+targetPts
		end
	elseif data.triggerName == 'finish' then finish()
	elseif data.triggerName == 'crystal_pickup' and data.event == 'enter' then crystalHandling.pickupCrystal(9)
	end
end

local function onRaceTick(raceTickTime) 
	scenarioTime = scenarioTime+raceTickTime 
	if targetTime > 0 then targetTime = targetTime-raceTickTime
	elseif targetScore ~= -1 then
		helper.flashUiMessage(''..(targetScore+1)..' pts', 2)
		targetScore = -1
	end
end

local function onScenarioChange(scenario)
	if scenario.state == 'pre-running' then
		if not crystalHandling.spawnCrystal(9) then crystalHandling.removeCrystal() end
	end
end

local function onPreRender(dt)
	if crystalHandling.spawnCrystal(9) then crystalHandling.updateCrystal() end --Only render rotations of the crystal if it is necessary
end

M.onPreRender = onPreRender
M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange= onScenarioChange
return M