local M = {}
local fileHandling = require('scenario/fileHandler')
local portal = {["scaleX"] = 1, ["scaleZ"] = 0.75}
local stabilisers = {["rot"] = 0}
local control = {["energyStored"] = 0, ["crystals"] = 0, ["catStored"] = 0, ["catReq"] = 100}
local pState = 'off'

local function fuel()
	local fuelLine = fileHandling.getLineFromSave(3)
	local fuel = 0
	for i = 1, #fuelLine do
		if tonumber(fuelLine:sub(i, i)) == 1 then fuel = fuel+1 end
	end
	
	if fuel ~= nil then control["crystals"] = fuel end
	
	ui_message('Fuel Level: '..fuel..' /9', 10, 'A')
end

local function applyCatalysts()
	local b, s, g, p, d = fileHandling.getListOfMedals()
	--Bronze   1x
	--Silver   2x
	--Gold     4x
	--Platinum 6x
	--Diamond  10x
	control["catStored"] = b*1 + s*2 + g*4 + p*6 + d*10
	ui_message('Catalysts Stored: '..control["catStored"]..' /100', 10, 'B')
end

---------------------------------------------------------------------------------------------
-- Main Control--
---------------------------------------------------------------------------------------------

local function update()
	if pState == 'energise' then
		control["energyStored"] = control["energyStored"]+0.05
		if control["energyStored"] < 50 then
			ui_message('Speed: '..math.floor(control["energyStored"]*2)..'%', 1, 'A')
			stabilisers["rot"] = stabilisers["rot"]+control["energyStored"]
		else ui_message('Energisation Complete!', 10, 'A')
		end
		TorqueScript.eval([[
			test1.rotation = "-1 0 0 ]]..(stabilisers["rot"]*1  )..[[";
			test2.rotation = "-1 0 0 ]]..(stabilisers["rot"]*1.1)..[[";
			test3.rotation = "-1 0 0 ]]..(stabilisers["rot"]*1.2)..[[";
			test4.rotation = "-1 0 0 ]]..(stabilisers["rot"]*1.2)..[[";
			test5.rotation = "-1 0 0 ]]..(stabilisers["rot"]*1.1)..[[";
			test6.rotation = "-1 0 0 ]]..(stabilisers["rot"]*1  )..[[";
		]])
	end
end

local function openPortal()
	if control["catStored"] >= control["catReq"] then pState = 'energise'
	else ui_message('Not Enough Catalysts!', 10, 'b')
	end
end

local function startup()
	fuel()
	applyCatalysts()
	openPortal()
end

M.update = update
M.startup = startup
return M